<script>
	import {createEventDispatcher} from 'svelte'
	const dispatch = createEventDispatcher()

	export let name
	let message

	let typingTime = false
	let typingInterval

	const doMessage = ()=>{
		dispatch('message', message)
		message = ''
		typingTime = false
	}
</script>
<style>
	div{display: flex;}
	#name{text-align: center;}
	#input{
		flex: 1 1 auto;
		align-self: stretch;
	}
	textarea{
		font-size: 1em;
		line-height: 1.5em;
		overflow: hidden;
		resize: none;
	}
</style>
<div>
	<input id='name' value={name} size={name.length||1} on:blur={event=>{
		const rename = event.target.value
		if(name !== rename){
			dispatch('rename', rename)
			name = rename
		}
	}}/>
	<textarea id='input' placeholder='message' autofocus rows='1' bind:value={message}
		on:input={()=>{
			if(!typingTime){
				dispatch('typing')
				typingInterval = setInterval(()=>{
					if(Date.now() >= typingTime){
						typingTime = false
						dispatch('stopTyping')
						clearInterval(typingInterval)
					}
				}, 200)
			}
			typingTime = Date.now() + 200
		}}
		on:keydown={event=>{
			//enter key & there is a message & no shift mod
			if(event.keyCode===13 && message.length && !event.shiftKey){
				doMessage()
				event.preventDefault() //prevents enter being leftover in next msg
			}
		}}
	/>
	<button on:click={doMessage}>send</button>
</div>
